/*
 * bdsd.c
 */

#define NUM_BIN_DIGITS_INT 32
typedef char bds_int[NUM_BIN_DIGITS_INT+1];

#include <stdio.h>
#include "bdsd.h"

static void int_to_bin_digits(int x, bds_int s)
{
  int keta;
  s[NUM_BIN_DIGITS_INT - 1] = '0' + (x & 1);
  x = (x >> 1) & 0x7fffffff;
  for (keta = NUM_BIN_DIGITS_INT - 2; keta >= 0; keta--) {
    s[keta] = '0' + (x & 1);
    x = x >> 1;
  }
  s[NUM_BIN_DIGITS_INT] = 0;
}

void double_to_bin_digits(double x, bdsd bds)
{
  union {
    double x;
    int xa[2];
  } data;
  data.x = x;
  int_to_bin_digits(data.xa[1], bds);
  int_to_bin_digits(data.xa[0], bds+NUM_BIN_DIGITS_INT);
}

void print_bdsd(bdsd a_bdsd)
{
  int i;
  printf("%c ", a_bdsd[0]);
  for (i = 1; i <= 11; i++)
    putchar(a_bdsd[i]);
  printf(" %s", a_bdsd + 12);
}
